Unit CodeTrans;

Interface
 Function InitGBK2BIG5Map:Boolean;
 Function InitGBK2JX0208Map:Boolean;
 Function InitGBK2JX0212Map:Boolean;
 Function InitGBK2JXUZPJMap:Boolean;
 Function TranslateGBK2BIG5byString(s:String):String;
 Function TranslateGBK2JISbyString(s:String):String;
 Function TranslateUnicodeStringGB18030(s:WideString):String;
 Procedure SetJISTranslateOption(iHZ,iJIS,iUZPJ,iISATTY: Integer);
 Function TryStartDrehtInterpret:Boolean;

Implementation
{$R codemap.res}

Uses
 SysUtils, StrUtils, Classes;

Var
 code: Array [0..48131] Of Byte;
 Jx0208: Array [0..94,0..94] Of Word;
 Jx0212: Array [0..94,0..94] Of Word;
 JxUzpj: Array [0..94,0..94] Of Word;
 UnicodeTable: Array [0..65535] Of String;
 sStr, oStr: String;
 HZ, JIS, UZPJ, KANJI, HANZI, ISATTY, iPos, iLength: Integer;

Function HexToInt(s: String):Integer;
 Type
  xP = ^Integer;
 Var
  a, b: PChar;
  c: Integer;
  i: xP;
 Begin
  a := PChar(LowerCase(s));
  b := AllocMem(8);
  For c := 0 to 7 Do (b + c)^ := #0;
  HexToBin(a, b, 8);
  i := xP(b);
  c := i^;
  FreeMem(b,8);
  HexToInt := c;
 End;

Function HexToIntRightLow(s: String):Integer;
 Var
  t: String;
  i: Integer;
 Begin
  t := '';
  For i:= (Length(s) Div 2) Downto 1 Do
   Begin
    t := t + s[i * 2 - 1] + s[i * 2];
   End;
  HexToIntRightLow := HexToInt(t);
 End;

Function TranslateUnicodeStringGB18030(s:WideString):String; // Notice > 255 Byte will return a Unicode String, Thats bad!
 Var
  i,j: Integer;
  p: String;
 Begin
  p := '';
  i := Length(s);
  For j := 1 to i Do
   Begin
    p := p + UnicodeTable[Ord(s[j])];
   End;
  TranslateUnicodeStringGB18030 := p;
 End;

Function InitUnicode2GB18030Map:Boolean;
 Var
  i,j,k,l: Integer;
  s: AnsiString;
  DataStream: TStringList;
  CodeMap: TResourceStream;
 Begin
  For i := 0 to 65535 Do UnicodeTable[i] := '';
  Try
   CodeMap := TResourceStream.Create(HInstance, 'UNICODE', PChar('MAP'));
   DataStream := TStringList.Create;
   DataStream.LoadFromStream(CodeMap);
   CodeMap.Free;
   For i := 0 to DataStream.Count - 1 Do
    Begin
     j := HexToInt(LeftStr(DataStream[i],4));
     k := (Length(DataStream[i]) - 5) Div 2;
     s := '';
     For l := 1 to k Do
      s := s + Chr(HexToInt(MidStr(DataStream[i],4 + l * 2,2)));
     UnicodeTable[j] := s; 
    End;
   DataStream.Free;
   InitUnicode2GB18030Map := True;
  Except
   InitUnicode2GB18030Map := False;
  End;
 End;

Function TryStartDrehtInterpret:Boolean;
 Begin
  SetJISTranslateOption(0,3,0,0);
  TryStartDrehtInterpret := False;
  If InitGBK2BIG5Map Then
   If InitGBK2JX0208Map Then
    If InitGBK2JX0212Map Then
     If InitGBK2JXUZPJMap Then
      If InitUnicode2GB18030Map Then
       TryStartDrehtInterpret := True;
 End;

Procedure SetJISTranslateOption(iHZ,iJIS,iUZPJ,iISATTY: Integer);
 Begin
  HZ := iHZ;
  JIS := iJIS;
  UZPJ := iUZPJ;
  ISATTY := iISATTY;
 End;

Function InitGBK2BIG5Map:Boolean;
 Var
  t: TResourceStream;
 Begin
  InitGBK2BIG5Map := True;
  Try
   t := TResourceStream.Create(HInstance, 'BIG5', PChar('MAP'));
   t.ReadBuffer(Code[0], 48132);
   t.Free;
  Except
   InitGBK2BIG5Map := False;
  End;
 End;

Function InitGBK2JX0208Map:Boolean;
 Label
  1;
 Var
  DataStream: TStringList;
  i,j,k,l,m,n,t: Integer;
  s: String;
  o,r: Word;
  zz: TResourceStream;
 Begin
  For i := 0 to 94 Do
   For k := 0 to 94 Do
    Jx0208[i,k] := 0;
  i := -1;
  k := -1;
  InitGBK2JX0208Map := True;
  Try
   DataStream := TStringList.Create;
   zz := TResourceStream.Create(HInstance, 'JIS0208', PChar('MAP'));
   DataStream.LoadFromStream(zz);
   zz.Free;
   For t := 0 to DataStream.Count - 1 Do
    Begin
     s := DataStream[t];
     j := Length(s);
     n := 1;
     If j >= 2 Then
      Begin
       l := Ord(s[1]) - Ord('0');
       m := Ord(s[2]) - Ord('0');
       If (l >= 0) And (l <= 9) And (m >= 0) And (m <= 9) Then
        Begin
         i := Trunc(l * 10 + m) - 1;
         k := -1;
         n := 3;
         Goto 1;
        End
       Else
        If i > - 1 Then
         Begin
        1:While (n + 1) <= j Do
           Begin
            o := Ord(s[n]);
            r := Ord(s[n+1]);
            Inc(k);
            Jx0208[i,k] := Trunc(o * 256) + r;
            Inc(n, 2);
           End;
          If Length(s) < 40 Then Inc(k, (40 - Length(s)) Div 2);
         End;
      End;
    End;
   DataStream.Free;
  Except
   InitGBK2JX0208Map := False;
  End;
 End;

Function InitGBK2JX0212Map:Boolean;
 Label
  1;
 Var
  DataStream: TStringList;
  i,j,k,l,m,n,t: Integer;
  s: String;
  o,r: Word;
  zz: TResourceStream;
 Begin
  For i := 0 to 94 Do
   For k := 0 to 94 Do
    Jx0212[i,k] := 0;
  i := -1;
  k := -1;
  InitGBK2JX0212Map := True;
  Try
   DataStream := TStringList.Create;
   zz := TResourceStream.Create(HInstance, 'JIS0212', PChar('MAP'));
   DataStream.LoadFromStream(zz);
   zz.Free;
   For t := 0 to DataStream.Count - 1 Do
    Begin
     s := DataStream[t];
     j := Length(s);
     n := 1;
     If j >= 2 Then
      Begin
       l := Ord(s[1]) - Ord('0');
       m := Ord(s[2]) - Ord('0');
       If (l >= 0) And (l <= 9) And (m >= 0) And (m <= 9) Then
        Begin
         i := Trunc(l * 10 + m) - 1;
         k := -1;
         n := 3;
         Goto 1;
        End
       Else
        If i > - 1 Then
         Begin
        1:While (n + 1) <= j Do
           Begin
            o := Ord(s[n]);
            r := Ord(s[n+1]);
            Inc(k);
            Jx0212[i,k] := Trunc(o * 256) + r;
            Inc(n, 2);
           End;
          If Length(s) < 40 Then Inc(k, (40 - Length(s)) Div 2);
         End;
      End;
    End;
   DataStream.Free;
  Except
   InitGBK2JX0212Map := False;
  End;
 End;

Function InitGBK2JXUZPJMap:Boolean;
 Label
  1;
 Var
  DataStream: TStringList;
  i,j,k,l,m,n,t: Integer;
  s: String;
  o,r: Word;
  zz: TResourceStream;
 Begin
  For i := 0 to 94 Do
   For k := 0 to 94 Do
    JxUzpj[i,k] := 0;
  i := -1;
  k := -1;
  InitGBK2JXUZPJMap := True;
  Try
   DataStream := TStringList.Create;
   zz := TResourceStream.Create(HInstance, 'JIS0212', PChar('MAP'));
   DataStream.LoadFromStream(zz);
   zz.Free;
   For t := 0 to DataStream.Count - 1 Do
    Begin
     s := DataStream[t];
     j := Length(s);
     n := 1;
     If j >= 2 Then
      Begin
       l := Ord(s[1]) - Ord('0');
       m := Ord(s[2]) - Ord('0');
       If (l >= 0) And (l <= 9) And (m >= 0) And (m <= 9) Then
        Begin
         i := Trunc(l * 10 + m) - 1;
         k := -1;
         n := 3;
         Goto 1;
        End
       Else
        If i > - 1 Then
         Begin
        1:While (n + 1) <= j Do
           Begin
            o := Ord(s[n]);
            r := Ord(s[n+1]);
            Inc(k);
            JxUzpj[i,k] := Trunc(o * 256) + r;
            Inc(n, 2);
           End;
          If Length(s) < 40 Then Inc(k, (40 - Length(s)) Div 2);           
         End;
      End;
    End;
   DataStream.Free;
  Except
   InitGBK2JXUZPJMap := False;
  End;
 End;

Function TranslateGBK2BIG5byString(s:String):String;
 Label
  1;
 Var
  i,j,k: Integer;
  t,u,n: String;
  ch1, ch2: Byte;
 Begin
  i := Length(s);
  t := '';
  j := 1;
  TranslateGBK2BIG5byString := t;
  If i > 0 Then
   Begin
    While j <= i Do
     Begin
      n := MidStr(s, j, 1);
      ch1 := Ord(n[1]);
      If j + 1 > i Then
       ch2 := 0
      Else
       Begin
        n := MidStr(s, j+1, 1);
        ch2 := Ord(n[1]);
       End;
      If ((ch1 >= 129) And (ch1 <= 254)) Then
       Begin
        If (((ch2 >= 64) And (ch2 < 127)) Or ((ch2 > 127) And (ch2 <= 254))) Then
         Begin
          k := trunc((( ch1 - 129 ) * 191 + (ch2 - 64)) * 2);
          If ((k > 48131) Or (k < 0)) Then
           Begin
            t := t + Chr(ch1);
            Goto 1;
           End;
          u := '';
          u := u + Chr(Code[k]);
          u := u + Chr(Code[k+1]);
          t := t + u;
          Inc(j);
         End
        Else
         t := t + Chr(ch1);
       End
      Else
       Begin
        t := t + Chr(ch1);
       End;
    1:Inc(j);
     End;
    TranslateGBK2BIG5byString := t;
   End;
 End;

Function TranslateGBK2JISbyString(s:String):String;
 Var
  h,l: Integer;

 Function GetC:Integer;
  Begin
   If iPos + 1 <= iLength Then
    Begin
     Inc(iPos);
     GetC := Ord(sStr[iPos]);
    End
   Else
    GetC := -1;
  End;

 Procedure UnGetC(c:Byte);
  Begin
   If iPos > 0 Then
    Begin
     sStr[iPos] := Chr(c);
     Dec(iPos);
    End;
  End;

 Procedure PutC(c: Byte);
  Begin
   oStr := oStr + Chr(c);
  End;

 Procedure Kanji0(c: Integer);
  Begin
   If (KANJI = 0) And (ISATTY = 1) Then oStr := oStr + #27 + '(B';
   PutC(c);
   KANJI := 0;
  End;

 Procedure Kanji1(l: Integer);
  Var
   h: Integer;
  Begin
   If JIS = 2 Then
    Begin
     PutC(l Div 256);
     PutC(l Mod 256);
    End
   Else
    If JIS = 3 Then
     Begin
      If l < 32768 Then
       Begin
        PutC(l Div 256);
        PutC(l Mod 256);
       End
      Else
       Begin
        If l < 57088 Then
         h := (l + 24832) Div 512
        Else
         h := (l + 57600) Div 512;
        If ((l Div 256) Mod 2) = 1 Then
         l := (l Mod 256) - 96
        Else
         l := (l Mod 256) - 2;
        If l < 128 Then Dec(l);
        PutC(h);
        PutC(l);
       End;
     End
    Else
     If l < 32768 Then
      Begin
       If (KANJI > 0) And (ISATTY = 1) Then oStr := oStr + #27 + '(B';
       If (l Div 256) <> Ord('_') Then PutC(l Div 256);
       PutC(l Mod 128);
       KANJI := 0;
      End
     Else
      Begin
       If (KANJI <> 1) And (ISATTY = 1) Then oStr := oStr + #27 + '$B';
       PutC((l Div 256) Mod 128);
       PutC(l Mod 128);
       KANJI :=1;
      End;
  End;

 Procedure Kanji2(c: Integer);
  Begin
   If (KANJI <> 2) And (ISATTY = 1) Then oStr := oStr + #27 + '(D';
   PutC((c Div 256) Mod 128);
   PutC(c Mod 128);
   KANJI := 2;
  End;

 Function IsHanzi:Integer;
  Var
   i,j: Integer;
  Begin
   i := GetC;
   If i > -1 Then UnGetC(i);
   While i >= 0 Do
    Begin
     i := GetC;
     If i = -1 Then
      Begin
       IsHanzi := -1;
       Exit;
      End;
     If (HZ>0) And (i=Ord('~')) Then
      Begin
       i := GetC;
       If i = Ord('{') Then
        Begin
         HANZI := 1;
	 HZ := 2;
	 Continue;
        End
       Else
        If i = Ord('}') Then
         Begin
          HANZI := 0;
	  HZ := 1;
	  Continue;
         End;
       UnGetc(i);
       IsHanzi := Ord('~');
       Exit;
      End
     Else
      If i = 27 Then
       Begin
        i := GetC;
        If i = Ord('$') Then
         Begin
          i := GetC;
	  If i = Ord('A') Then
           Begin
	    HANZI := 1;
	    Continue;
	   End
	  Else
           If i = Ord('(') Then
            Begin
             j := GetC;
	     If j = Ord('A') Then
              Begin
               HANZI := 1;
	       Continue;
	      End
	     Else
              If j = Ord('E') Then
               Begin
	        HANZI := 1;
	        Continue;
	       End;
	     UnGetC(j);
            End;
	  HANZI := 0;
          UnGetc(i);
	  UnGetc(Ord('$'));
         End
        Else
         If (HANZI=1) And (i=Ord('(')) Then
          Begin
	   HANZI := 0;
           i := GetC;
           If i = Ord('B') Then
	    Continue
	   Else
            If i = Ord('T') Then Continue;
	   UnGetC(i);
	   UnGetC(Ord('('));
          End
         Else
	  UnGetC(i);
        HANZI := HANZI Or 2;
        IsHanzi := 27;
        Exit;
     End
    Else
     If (i>160) And (i<255) Then
      Begin
       j := GetC;
       If (j>160) And (j<255) Then
        Begin
         IsHanzi := (i Shl 8) + j;
         Exit;
        End;
       UnGetc(j);
      End
     Else
      If (HANZI=1) And (i>32) And (i<127) Then
       Begin
        j := GetC;
        If (j>32) And (j<127) Then
         Begin
          IsHanzi := (i Shl 8) + j + 32896;
          Exit;
         End;
        UnGetC(j);
       End
      Else
       If ((HANZI>1) And ((i<32) Or ((i>=Ord('@')) And (i<=Ord('Z'))) Or ((i>=Ord('a')) And (i<=Ord('z'))))) Then
        HANZI := HANZI And 1
       Else
        If (HZ=2) And (i=13) Then
         Begin
          HANZI := 0;
          HZ := 1;
         End;
      IsHanzi := i;
      Exit;
    End;
   IsHanzi := -1;
  End;

 Begin
  iPos := 0;
  sStr := s;
  oStr := '';
  iLength := Length(sStr);
  l := IsHanzi;
  iPos := 0;
  While l >= 0 Do
   Begin
    l := IsHanzi;
    If l = -1 Then
     Begin
      TranslateGBK2JISbyString := oStr;
      Exit;
     End;
    If l < 256 Then
     Kanji0(l)
    Else
     Begin
      h := (l Div 256) - 161;
      l := (l Mod 256) - 161;
      If (JIS=0) And (Jx0212[h,l]>0) Then
       Kanji2(Jx0212[h,l])
      Else
       If (UZPJ>0) And (JxUzpj[h,l]>0) Then
	Kanji1(JxUzpj[h,l])
       Else
        If (Jx0208[h,l]>0) Then
	 Kanji1(Jx0208[h,l])
        Else
	 Kanji1(8224);
     End;
   End;
  TranslateGBK2JISbyString := oStr;
 End;

End.
